<?php

namespace Intuit\Commands;

use GuzzleHttp\Exception\ConnectException;
use Illuminate\Console\Command;
use Intuit\Exceptions\ConnectionIssueException;
use Intuit\Exceptions\NotFoundException;
use Intuit\Traits\ProviderTokenTrait;

class TaxCodeGet extends Command
{
	use ProviderTokenTrait;

	/**
	 * The name and signature of the console command.
	 *
	 * @var string
	 */
	protected $signature = 'intuit:taxcode:get'
		.' {id : Taxcode ID}'
		.' {user? : User Email}';

	/**
	 * The console command description.
	 *
	 * @var string
	 */
	protected $description = 'Get the defined tax codes from the accounting provider';

	/**
	 * Execute the console command.
	 *
	 * @return int
	 */
	public function handle()
	{
		$to = $this->providerToken($this->argument('user'));

		try {
			$result = $to->API()->getTaxCodeQuery($this->argument('id'));
			dd($result,$result->getTaxRateRef());

		} catch (ConnectException|ConnectionIssueException $e) {
			$this->error($e->getMessage());

			return self::FAILURE;

		} catch (NotFoundException $e) {
			$this->error('Nothing found');

			return self::FAILURE;
		}

		return self::SUCCESS;
	}
}