<?php

namespace Intuit\Models;

use Illuminate\Support\Arr;
use Jenssegers\Model\Model;

use Intuit\Traits\CompareAttributes;

/*
  {#5766
	+"AllowIPNPayment": false
	+"AllowOnlinePayment": false
	+"AllowOnlineCreditCardPayment": false
	+"AllowOnlineACHPayment": false
	+"domain": "QBO"
	+"sparse": false
	+"Id": "192"
	+"SyncToken": "0"
	+"MetaData": {#5765
	  +"CreateTime": "2018-06-09T07:41:49-07:00"
	  +"LastUpdatedTime": "2018-06-09T07:41:49-07:00"
	}
	+"CustomField": array:1 [
	  0 => {#5764
		+"DefinitionId": "1"
		+"Name": "Event Rep"
		+"Type": "StringType"
	  }
	]
	+"DocNumber": "1022"
	+"TxnDate": "2018-06-10"
	+"CurrencyRef": {#5763
	  +"value": "AUD"
	  +"name": "Australian Dollar"
	}
	+"ExchangeRate": 1
	+"LinkedTxn": []
	+"Line": array:2 [
	  0 => {#5762
		+"Id": "1"
		+"LineNum": 1
		+"Description": "Holiday party - gold level"
		+"Amount": 6000.0
		+"DetailType": "SalesItemLineDetail"
		+"SalesItemLineDetail": {#5761
		  +"TaxInclusiveAmt": 6600.0
		  +"ItemRef": {#5760
			+"value": "7"
			+"name": "Holiday party:Gold party"
		  }
		  +"UnitPrice": 2000
		  +"Qty": 3
		  +"ItemAccountRef": {#5759
			+"value": "1"
			+"name": "Services"
		  }
		  +"TaxCodeRef": {#5758
			+"value": "10"
		  }
		}
	  }
	  1 => {#5757
		+"Amount": 6000.0
		+"DetailType": "SubTotalLineDetail"
		+"SubTotalLineDetail": {#5756}
	  }
	]
	+"TxnTaxDetail": {#5755
	  +"TotalTax": 600.0
	  +"TaxLine": array:1 [
		0 => {#5754
		  +"Amount": 600.0
		  +"DetailType": "TaxLineDetail"
		  +"TaxLineDetail": {#5753
			+"TaxRateRef": {#5752
			  +"value": "20"
			}
			+"PercentBased": true
			+"TaxPercent": 10
			+"NetAmountTaxable": 6000.0
		  }
		}
	  ]
	}
	+"RecurDataRef": {#5751
	  +"value": "11"
	}
	+"CustomerRef": {#5750
	  +"value": "17"
	  +"name": "Jordan Burgess"
	}
	+"CustomerMemo": {#5749
	  +"value": "Thanks for your business!  We appreciate referrals!"
	}
	+"BillAddr": {#5748
	  +"Id": "15"
	  +"Line1": "1 Success Way"
	  +"City": "Sydney"
	  +"CountrySubDivisionCode": "NSW"
	  +"PostalCode": "2000"
	  +"Lat": "-33.871226"
	  +"Long": "150.897656"
	}
	+"FreeFormAddress": false
	+"SalesTermRef": {#5747
	  +"value": "3"
	}
	+"DueDate": "2018-07-10"
	+"GlobalTaxCalculation": "TaxInclusive"
	+"TotalAmt": 6600.0
	+"HomeTotalAmt": 6600.0
	+"PrintStatus": "NotSet"
	+"EmailStatus": "NotSet"
	+"Balance": 6600.0
	+"HomeBalance": 6600.0
  }
  +"time": "2022-08-13T21:15:37.254-07:00"
 */

final class Invoice extends Model
{
	use CompareAttributes;

	public function __get($key) {
		$keymap = [
			'id' => 'Id',
			'synctoken' => 'SyncToken',
			'invoice_num' => 'DocNumber',
			'invoice_date' => 'TxnDate',
			'due_date' => 'DueDate',
		];

		switch ($key) {
			case 'created_at':
				return object_get($this->getAttribute('MetaData'),'CreateTime');
			case 'updated_at':
				return object_get($this->getAttribute('MetaData'),'LastUpdatedTime');

			default:
				return parent::__get(Arr::get($keymap,$key,$key));
		}
	}
}