<?php

namespace Intuit\Providers;

use Illuminate\Routing\Router;
use Illuminate\Support\ServiceProvider;
use Intuit\Commands\{AccountGet,InvoiceGet,PaymentGet,TaxCodeGet};

/**
 * Class IntuitServiceProvider.
 */
class IntuitServiceProvider extends ServiceProvider
{
	private string $_path = '';

	/**
	 * Bootstrap the application services.
	 *
	 * @param Router $router
	 */
	public function boot(Router $router)
	{
		$this->mergeConfigFrom($this->_path.'/config/intuit.php','intuit');

		$this->commands([
			AccountGet::class,
			InvoiceGet::class,
			PaymentGet::class,
			TaxCodeGet::class,
		]);
	}

	/**
	 * Register the application services.
	 *
	 * @return void
	 */
	public function register()
	{
		if (! $this->_path)
			$this->_path = realpath(__DIR__.'/../../src');
	}
}