<?php

namespace Intuit\Traits;

use App\Models\{ProviderOauth,ProviderToken,User};
use Intuit\Exceptions\NotTokenException;

/**
 * Return a provider token for API calls
 */
trait ProviderTokenTrait
{
	private const provider = 'intuit';

	/**
	 * Return a provider token to use for an API call
	 *
	 * @return ProviderToken
	 */
	protected function providerToken(string $user=NULL): ProviderToken
	{
		$uo = User::where('email',$user ?: config('osb.admin'))
			->sole();

		$so = ProviderOauth::where('name',self::provider)
			->sole();

		if (! ($to=$so->token($uo)))
			throw new NotTokenException(sprintf('Unknown Tokens for [%s]',$uo->email));

		return $to;
	}
}